//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// Z poniszym kodem nie jest zwizana adna gwarancja poprawnoci dziaania.
// Program zosta doczony do ksiki ".NET CLR. Ksiga eksperta" w celu
// ilustracji koncepcji i zasad przedstawionych w tej ksice. Program moe by 
// uywany na wasne ryzyko.
//
// Przyznaje si prawo do uycia lub kopiowania tego oprogramowania do dowolnego celu
// bez koniecznoci ponoszenia adnych opat pod warunkiem, e powysze uwagi zostan 
// zachowane we wszystkich kopiach. Przyznaje si take prawo do modyfikacji kodu
// i dystrybucji zmodyfikowanego kodu pod warunkiem zachowania powyszych uwag
// oraz doczenia informacji mwicej o modyfikacji kodu.
//
// 
using System;
using System.IO;
using System.Drawing;
using System.Collections;
using System.Diagnostics;
using System.ComponentModel;
using System.Windows.Forms;
using System.Runtime.Remoting;

using System.Runtime.Remoting.Channels;
using System.Runtime.Remoting.Channels.Http;

namespace CLRUnleashed.Remoting
{
	/// <summary>
	/// Podsumowanie dla TimeForm.
	/// </summary>
	public class TimeForm : System.Windows.Forms.Form
	{
		private System.ComponentModel.IContainer components;

		public TimeForm()
		{
			//
			// Wymagane do obsugi Windows Form Designer
			//
			InitializeComponent();

			string configFilename = "timeclient.exe.config";

			if(!Initialize(configFilename))
				return;

			try
			{
				timeService = new TimeObject();
				if (true == RemotingServices.IsTransparentProxy(timeService))
				{
					Debug.WriteLine("TimeObject activated on server");
					timer.Enabled = true;
				}
			}
			catch(Exception e)
			{
				timeService = null;
				Debug.WriteLine(e);
			}
		}

		/// <summary>
		/// Oczyszczenie uywanych zasobw.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Metoda wymagana do obsugi Designera - nie naley modyfikowa
		/// zawartoci tej metody przy uyciu edytora kodu.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			this.date = new System.Windows.Forms.TextBox();
			this.time = new System.Windows.Forms.TextBox();
			this.timer = new System.Windows.Forms.Timer(this.components);
			this.dateCount = new System.Windows.Forms.TextBox();
			this.timeCount = new System.Windows.Forms.TextBox();
			this.contextMenu = new System.Windows.Forms.ContextMenu();
			this.SuspendLayout();
			// 
			// date
			// 
			this.date.BackColor = System.Drawing.Color.Black;
			this.date.Font = new System.Drawing.Font("Arial Unicode MS", 20.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.date.ForeColor = System.Drawing.Color.Lime;
			this.date.Location = new System.Drawing.Point(8, 32);
			this.date.Name = "date";
			this.date.Size = new System.Drawing.Size(400, 44);
			this.date.TabIndex = 0;
			this.date.Text = "";
			this.date.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			// 
			// time
			// 
			this.time.BackColor = System.Drawing.Color.Black;
			this.time.Font = new System.Drawing.Font("Arial Unicode MS", 20.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.time.ForeColor = System.Drawing.Color.Lime;
			this.time.Location = new System.Drawing.Point(8, 123);
			this.time.Name = "time";
			this.time.Size = new System.Drawing.Size(400, 44);
			this.time.TabIndex = 1;
			this.time.Text = "";
			this.time.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			// 
			// timer
			// 
			this.timer.Interval = 1000;
			this.timer.Tick += new System.EventHandler(this.OnTick);
			// 
			// dateCount
			// 
			this.dateCount.Location = new System.Drawing.Point(184, 80);
			this.dateCount.Name = "dateCount";
			this.dateCount.Size = new System.Drawing.Size(56, 20);
			this.dateCount.TabIndex = 2;
			this.dateCount.Text = "";
			this.dateCount.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			// 
			// timeCount
			// 
			this.timeCount.Location = new System.Drawing.Point(184, 176);
			this.timeCount.Name = "timeCount";
			this.timeCount.Size = new System.Drawing.Size(56, 20);
			this.timeCount.TabIndex = 3;
			this.timeCount.Text = "";
			this.timeCount.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			// 
			// contextMenu
			// 
			this.contextMenu.Popup += new System.EventHandler(this.OnContextMenu);
			// 
			// TimeForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(416, 222);
			this.ContextMenu = this.contextMenu;
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.timeCount,
																		  this.dateCount,
																		  this.time,
																		  this.date});
			this.Name = "TimeForm";
			this.Text = "Zdalny czas";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// Gwny punkt wejcia dla aplikacji.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new TimeForm());
		}

		private static bool Initialize(string configfile)
		{
			if(!File.Exists(configfile))
			{
				configfile = @"..\..\" + configfile;
				if(!File.Exists(configfile))
					return false;
			}
			RemotingConfiguration.Configure(configfile);
			return true;
		}

		private System.Windows.Forms.TextBox date;
		private System.Windows.Forms.TextBox time;
		private System.Windows.Forms.Timer timer;
		private System.Windows.Forms.TextBox dateCount;
		private System.Windows.Forms.TextBox timeCount;
		private System.Windows.Forms.ContextMenu contextMenu;
		private TimeObject timeService = null;

		private void OnTick(object sender, System.EventArgs e)
		{
			if(timeService != null)
			{
				try
				{
					time.Text = timeService.Time;
					date.Text = timeService.Date;
					dateCount.Text = Convert.ToString(timeService.DateCount);
					timeCount.Text = Convert.ToString(timeService.TimeCount);
				}
				catch(Exception exception)
				{
					Debug.WriteLine(exception);
					timeService = null;
					timer.Enabled = false;
				}
			}
		}

		protected void OnContextCountry(object sender, System.EventArgs e)
		{
			string culture;
			MenuItem m = (MenuItem)sender;
			culture = m.Text;
			try
			{
				timeService = new TimeObject(culture);
				if (true == RemotingServices.IsTransparentProxy(timeService))
				{
					timer.Enabled = true;
				}
			}
			catch(Exception exception)
			{
				timeService = null;
				Debug.WriteLine(exception);
			}
		}
		private void OnContextMenu(object sender, System.EventArgs e)
		{
			if(contextMenu.MenuItems.Count > 0)
				return;
			MenuItem menuFrance = new MenuItem();
			menuFrance.Click += new System.EventHandler(OnContextCountry);
			menuFrance.Text = "fr-fr";
			menuFrance.Index = 0;
			MenuItem menuGermany = new MenuItem();
			menuGermany.Click += new System.EventHandler(OnContextCountry);
			menuGermany.Text = "de-de";
			menuGermany.Index = 1;
			MenuItem menuSpain = new MenuItem();
			menuSpain.Click += new System.EventHandler(OnContextCountry);
			menuSpain.Text = "es-es";
			menuSpain.Index = 2;
			MenuItem menuIndia = new MenuItem();
			menuIndia.Click += new System.EventHandler(OnContextCountry);
			menuIndia.Text = "ta-IN";
			menuIndia.Index = 3;
			MenuItem menuJapan = new MenuItem();
			menuJapan.Click += new System.EventHandler(OnContextCountry);
			menuJapan.Text = "ja-jp";
			menuJapan.Index = 4;
			MenuItem menuSaudiArabia = new MenuItem();
			menuSaudiArabia.Click += new System.EventHandler(OnContextCountry);
			menuSaudiArabia.Text = "ar-sa";
			menuSaudiArabia.Index = 5;
			contextMenu.MenuItems.AddRange(new MenuItem[] { menuFrance,
                                                            menuGermany,
                                                            menuSpain,
															menuIndia,
															menuJapan,
                                                            menuSaudiArabia } );
		}
	}
}
