//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// Z poniszym kodem nie jest zwizana adna gwarancja poprawnoci dziaania.
// Program zosta doczony do ksiki ".NET CLR. Ksiga eksperta" w celu
// ilustracji koncepcji i zasad przedstawionych w tej ksice. Program moe by 
// uywany na wasne ryzyko.
//
// Przyznaje si prawo do uycia lub kopiowania tego oprogramowania do dowolnego celu
// bez koniecznoci ponoszenia adnych opat pod warunkiem, e powysze uwagi zostan 
// zachowane we wszystkich kopiach. Przyznaje si take prawo do modyfikacji kodu
// i dystrybucji zmodyfikowanego kodu pod warunkiem zachowania powyszych uwag
// oraz doczenia informacji mwicej o modyfikacji kodu.
//
//  
using System;
using System.Threading;
using System.Globalization;
using System.Diagnostics;

namespace CLRUnleashed.Remoting
{
	/// <summary>
	/// Podsumowanie dla TimeObject.
	/// </summary>
	public class TimeObject : MarshalByRefObject
	{
		public TimeObject()
		{
			Console.WriteLine("TimeObject activated");
			dateCount = 0;
			timeCount = 0;
		}
		public TimeObject(string culture)
		{
			Console.WriteLine("TimeObject({0}) zosta aktywowany", culture);
			
			try
			{
				ci = new CultureInfo(culture);
			}
			catch(ArgumentException e)
			{
				Debug.WriteLine(e);
				ci = null;
			}

			dateCount = 0;
			timeCount = 0;
		}
		public string Time
		{
			get
			{
				timeCount++;
				if(ci != null)
					Thread.CurrentThread.CurrentCulture = ci;
				return DateTime.Now.ToLongTimeString();
			}
		}
		public string Date
		{
			get
			{
				dateCount++;
				if(ci != null)
					Thread.CurrentThread.CurrentCulture = ci;
				return DateTime.Now.ToLongDateString();
			}
		}
		public int DateCount
		{
			get
			{
				return dateCount;
			}
		}
		public int TimeCount
		{
			get
			{
				return timeCount;
			}
		}

		private int dateCount;
		private int timeCount;
		private CultureInfo ci = null;
	}
}
