//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// Z poniszym kodem nie jest zwizana adna gwarancja poprawnoci dziaania.
// Program zosta doczony do ksiki ".NET CLR. Ksiga eksperta" w celu
// ilustracji koncepcji i zasad przedstawionych w tej ksice. Program moe by 
// uywany na wasne ryzyko.
//
// Przyznaje si prawo do uycia lub kopiowania tego oprogramowania do dowolnego celu
// bez koniecznoci ponoszenia adnych opat pod warunkiem, e powysze uwagi zostan 
// zachowane we wszystkich kopiach. Przyznaje si take prawo do modyfikacji kodu
// i dystrybucji zmodyfikowanego kodu pod warunkiem zachowania powyszych uwag
// oraz doczenia informacji mwicej o modyfikacji kodu.
//
// 
#include <iostream>

#using <mscorlib.dll>
using namespace System;

struct UnmanagedException
{
	UnmanagedException(int e) : err(e)
	{
	}
	int Error()
	{
		return err;
	}
private:
	int err;
};

void ExceptionGenerator(int i)
{
   if (i == 0)
   {
	   // Zgasza wyjtek, ktry nie jest oparty o SystemException,
	   // przez co nie jest to zarzdzany wyjtek
	   UnmanagedException *e = new UnmanagedException(10);
	   throw (e);
   }
   else if(i == 1)
   {
	   //  Zarzdzany wyjtek
	   Exception *e = new Exception;
	   throw e;
   }
   else if(i == 2)
   {
	   // Dzielenie przez zero
	   int a = 0;
	   int b = 1;
	   int c = b/a;
   }
   else if(i == 3)
   {
	   // Puste odwoanie
	   int *pint = 0;
	   std::cout << pint[10] << std::endl;
   }
   else if(i == 4)
   {
	   // Przepenienie stosu
	   ExceptionGenerator(4);
   }
   else if(i == 5)
   {
	   // Nieokrelony
	   throw;
   }
}

void FilterTest()
{
	for (int i = 0; i < 1; i++)
	{
		__try
		{
			throw new InvalidOperationException("To jest test");
		}
		__except (i == 0)
		{
			Console::WriteLine(S"\nPrzechwycono i==0 wyjtek\n");
		}
	}
}

int main()
{
	for (int i = 0; i < 6; i++)
	{
		try
		{
			ExceptionGenerator(i);
		}
		catch (UnmanagedException* u)
		{
			Console::WriteLine(S"\nPrzechwycono niezarzdzany wyjtek\n");
			std::cout << u->Error() << std::endl;
		}
		catch (Exception* e)
		{
			Console::WriteLine(S"\nPrzechwycono zarzdzany wyjtek\n");
			Console::WriteLine(e->ToString());
		}
		catch (...)
		{
			Console::WriteLine(S"\nPrzechwycono oglny wyjtek\n");
		}
	}

	FilterTest();

	return 0;
}
