//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// Z poniszym kodem nie jest zwizana adna gwarancja poprawnoci dziaania.
// Program zosta doczony do ksiki ".NET CLR. Ksiga eksperta" w celu
// ilustracji koncepcji i zasad przedstawionych w tej ksice. Program moe by 
// uywany na wasne ryzyko.
//
// Przyznaje si prawo do uycia lub kopiowania tego oprogramowania do dowolnego celu
// bez koniecznoci ponoszenia adnych opat pod warunkiem, e powysze uwagi zostan 
// zachowane we wszystkich kopiach. Przyznaje si take prawo do modyfikacji kodu
// i dystrybucji zmodyfikowanego kodu pod warunkiem zachowania powyszych uwag
// oraz doczenia informacji mwicej o modyfikacji kodu.
//
//  
using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Diagnostics;
using System.Resources;
using System.Reflection;
using System.Globalization;
using System.Threading;

namespace GlobalApp
{
	/// <summary>
	/// Podsumowanie dla Form1.
	/// </summary>
	public class GlobalForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.ComboBox languageSelection;
		private System.Windows.Forms.TextBox translatedText;
		private System.Windows.Forms.Button exit;
		private System.Windows.Forms.Label date;
		private System.Windows.Forms.Label calendar;
		private System.Windows.Forms.TextBox floatNumber;
		private System.Windows.Forms.TextBox currencyNumber;
		private System.Windows.Forms.Label localeID;
		private System.Windows.Forms.Label LCIDLabel;
		private System.Windows.Forms.Label calendarLabel;
		private System.Windows.Forms.Label dateLabel;
		private System.Windows.Forms.Label numberLabel;
		private System.Windows.Forms.Label currencyLabel;
		private System.Windows.Forms.Label metricLabel;
		private System.Windows.Forms.Label metric;
		private System.Windows.Forms.Label countryName;
		private System.Windows.Forms.Label reginoInfoLabel;
		private System.Windows.Forms.TextBox usersTextBox;
		private System.Windows.Forms.Label timeLabel;
		private System.Windows.Forms.Label time;
		private System.Windows.Forms.PictureBox flagImage;
		/// <summary>
		/// Wymagana zmienna.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public GlobalForm()
		{
			//
			// Wymagane do obsugi Windows Form Designer
			//
			InitializeComponent();

			ResourceManager rm = new ResourceManager("GlobalApp.Strings", Assembly.GetExecutingAssembly());
			LanguageIdentifier[] lida = new LanguageIdentifier[] {
																	 new LanguageIdentifier((string)rm.GetString("ArabicSaudiArabia"), "ar-SA"),
																	 new LanguageIdentifier((string)rm.GetObject("ArabicEgypt"), "ar-EG"),
																	 new LanguageIdentifier((string)rm.GetObject("ArabicSyria"), "ar-SY"),
																	 new LanguageIdentifier((string)rm.GetObject("German"), "de-DE"),
																	 new LanguageIdentifier((string)rm.GetObject("GermanSwitzerland"), "de-CH"),
																	 new LanguageIdentifier((string)rm.GetObject("GermanLuxembourg"), "de-LU"),
																	 new LanguageIdentifier((string)rm.GetObject("GermanAustria"), "de-AT"),
																	 new LanguageIdentifier((string)rm.GetObject("GermanLiechtenstein"), "de-LI"),
																	 new LanguageIdentifier((string)rm.GetObject("Greek"), "el-GR"),
																	 new LanguageIdentifier((string)rm.GetObject("Czech"), "cs-CZ"),
																	 new LanguageIdentifier((string)rm.GetObject("Danish"), "da-DK"),
																	 new LanguageIdentifier((string)rm.GetObject("Finnish"), "fi-FI"),
																	 new LanguageIdentifier((string)rm.GetObject("Bulgarian"), "bg-BG"),
																	 new LanguageIdentifier((string)rm.GetObject("Icelandic"), "is-IS"),
																	 new LanguageIdentifier((string)rm.GetObject("Dutch"), "nl-NL"),
																	 new LanguageIdentifier((string)rm.GetObject("Norwegian"), "nb-NO"),
																	 new LanguageIdentifier((string)rm.GetObject("Polish"), "pl-PL"),
																	 new LanguageIdentifier((string)rm.GetObject("Romanian"), "ro-RO"),
																	 new LanguageIdentifier((string)rm.GetObject("Russian"), "ru-RU"),
																	 new LanguageIdentifier((string)rm.GetObject("Croatian"), "hr-HR"),
																	 new LanguageIdentifier((string)rm.GetObject("Albanian"), "sq-AL"),
																	 new LanguageIdentifier((string)rm.GetObject("Swedish"), "sv-SE"),
																	 new LanguageIdentifier((string)rm.GetObject("Indonesian"), "id-ID"),
																	 new LanguageIdentifier((string)rm.GetObject("Ukrainian"), "uk-UA"),
																	 new LanguageIdentifier((string)rm.GetObject("Sanskrit"), "sa-IN"),
																	 new LanguageIdentifier((string)rm.GetObject("Tamil"), "ta-IN"),
																	 new LanguageIdentifier((string)rm.GetObject("Marathi"), "mr-IN"),
																	 new LanguageIdentifier((string)rm.GetObject("Kannada"), "kn-IN"),
																	 new LanguageIdentifier((string)rm.GetObject("Telugu"), "te-IN"),
																	 new LanguageIdentifier((string)rm.GetObject("EnglishAustralia"), "en-AU"),
																	 new LanguageIdentifier((string)rm.GetObject("EnglishNewZealand"), "en-NZ"),
																	 new LanguageIdentifier((string)rm.GetObject("EnglishCanada"), "en-CA"),
																	 new LanguageIdentifier((string)rm.GetObject("EnglishUnitedKingdom"), "en-GB"),
																	 new LanguageIdentifier((string)rm.GetObject("EnglishUS"), "en-US"),
																	 new LanguageIdentifier((string)rm.GetObject("EnglishIreland"), "en-IE"),
																	 new LanguageIdentifier((string)rm.GetObject("EnglishSouthAfrica"), "en-ZA"),
																	 new LanguageIdentifier((string)rm.GetObject("EnglishJamaica"), "en-JM"),
																	 new LanguageIdentifier((string)rm.GetObject("EnglishBelize"), "en-BZ"),
																	 new LanguageIdentifier((string)rm.GetObject("EnglishTrinidadTobago"), "en-TT"),
																	 new LanguageIdentifier((string)rm.GetObject("EnglishZimbabwe"), "en-ZW"),
																	 new LanguageIdentifier((string)rm.GetObject("EnglishPhilippines"), "en-PH"),
																	 new LanguageIdentifier((string)rm.GetObject("SpanishSpain"), "es-ES"),
																	 new LanguageIdentifier((string)rm.GetObject("SpanishMexico"), "es-MX"),
																	 new LanguageIdentifier((string)rm.GetObject("SpanishGuatemala"), "es-GT"),
																	 new LanguageIdentifier((string)rm.GetObject("SpanishCostaRica"), "es-CR"),
																	 new LanguageIdentifier((string)rm.GetObject("SpanishPanama"), "es-PA"),
																	 new LanguageIdentifier((string)rm.GetObject("SpanishArgentina"), "es-AR"),
																	 new LanguageIdentifier((string)rm.GetObject("French"), "fr-FR"),
																	 new LanguageIdentifier((string)rm.GetObject("Hebrew"), "he-IL"),
																	 new LanguageIdentifier((string)rm.GetObject("Hindi"), "hi-IN"),
																	 new LanguageIdentifier((string)rm.GetObject("Armenian"), "hy-AM"),
																	 new LanguageIdentifier((string)rm.GetObject("Italian"), "it-IT"),
																	 new LanguageIdentifier((string)rm.GetObject("Japanese"), "ja-JP"),
																	 new LanguageIdentifier((string)rm.GetObject("KoreanSouthKorea"), "ko-KR"),
																	 new LanguageIdentifier((string)rm.GetObject("KoreanNorthKorea"), "ko-KP"),
																	 new LanguageIdentifier((string)rm.GetObject("Thai"), "th-TH"),
																	 new LanguageIdentifier((string)rm.GetObject("Turkish"), "tr-TR"),
																	 new LanguageIdentifier((string)rm.GetObject("Urdu"), "ur-PK"),
																	 new LanguageIdentifier((string)rm.GetObject("Vietnamese"), "vi-VN"),
																	 new LanguageIdentifier((string)rm.GetObject("Swahili"), "sw-KE"),
																	 new LanguageIdentifier((string)rm.GetObject("ChinesePRC"), "zh-CN"),
																	 new LanguageIdentifier((string)rm.GetObject("ChineseTaiwan"), "zh-TW"),
																	 new LanguageIdentifier((string)rm.GetObject("ChineseSingapore"), "zh-SG")
																 };
			languageSelection.Items.AddRange(lida);
		}

		/// <summary>
		/// Oczyszczenie uywanych zasobw.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Metoda wymagana do obsugi Designera - nie naley modyfikowa
		/// zawartoci tej metody przy uyciu edytora kodu.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(GlobalForm));
			this.LCIDLabel = new System.Windows.Forms.Label();
			this.countryName = new System.Windows.Forms.Label();
			this.timeLabel = new System.Windows.Forms.Label();
			this.flagImage = new System.Windows.Forms.PictureBox();
			this.numberLabel = new System.Windows.Forms.Label();
			this.usersTextBox = new System.Windows.Forms.TextBox();
			this.reginoInfoLabel = new System.Windows.Forms.Label();
			this.calendar = new System.Windows.Forms.Label();
			this.currencyLabel = new System.Windows.Forms.Label();
			this.translatedText = new System.Windows.Forms.TextBox();
			this.date = new System.Windows.Forms.Label();
			this.metric = new System.Windows.Forms.Label();
			this.time = new System.Windows.Forms.Label();
			this.metricLabel = new System.Windows.Forms.Label();
			this.currencyNumber = new System.Windows.Forms.TextBox();
			this.languageSelection = new System.Windows.Forms.ComboBox();
			this.localeID = new System.Windows.Forms.Label();
			this.exit = new System.Windows.Forms.Button();
			this.floatNumber = new System.Windows.Forms.TextBox();
			this.dateLabel = new System.Windows.Forms.Label();
			this.calendarLabel = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// LCIDLabel
			// 
			this.LCIDLabel.AccessibleDescription = ((string)(resources.GetObject("LCIDLabel.AccessibleDescription")));
			this.LCIDLabel.AccessibleName = ((string)(resources.GetObject("LCIDLabel.AccessibleName")));
			this.LCIDLabel.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("LCIDLabel.Anchor")));
			this.LCIDLabel.AutoSize = ((bool)(resources.GetObject("LCIDLabel.AutoSize")));
			this.LCIDLabel.Cursor = ((System.Windows.Forms.Cursor)(resources.GetObject("LCIDLabel.Cursor")));
			this.LCIDLabel.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("LCIDLabel.Dock")));
			this.LCIDLabel.Enabled = ((bool)(resources.GetObject("LCIDLabel.Enabled")));
			this.LCIDLabel.Font = ((System.Drawing.Font)(resources.GetObject("LCIDLabel.Font")));
			this.LCIDLabel.Image = ((System.Drawing.Image)(resources.GetObject("LCIDLabel.Image")));
			this.LCIDLabel.ImageAlign = ((System.Drawing.ContentAlignment)(resources.GetObject("LCIDLabel.ImageAlign")));
			this.LCIDLabel.ImageIndex = ((int)(resources.GetObject("LCIDLabel.ImageIndex")));
			this.LCIDLabel.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("LCIDLabel.ImeMode")));
			this.LCIDLabel.Location = ((System.Drawing.Point)(resources.GetObject("LCIDLabel.Location")));
			this.LCIDLabel.Name = "LCIDLabel";
			this.LCIDLabel.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("LCIDLabel.RightToLeft")));
			this.LCIDLabel.Size = ((System.Drawing.Size)(resources.GetObject("LCIDLabel.Size")));
			this.LCIDLabel.TabIndex = ((int)(resources.GetObject("LCIDLabel.TabIndex")));
			this.LCIDLabel.Text = resources.GetString("LCIDLabel.Text");
			this.LCIDLabel.TextAlign = ((System.Drawing.ContentAlignment)(resources.GetObject("LCIDLabel.TextAlign")));
			this.LCIDLabel.Visible = ((bool)(resources.GetObject("LCIDLabel.Visible")));
			// 
			// countryName
			// 
			this.countryName.AccessibleDescription = ((string)(resources.GetObject("countryName.AccessibleDescription")));
			this.countryName.AccessibleName = ((string)(resources.GetObject("countryName.AccessibleName")));
			this.countryName.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("countryName.Anchor")));
			this.countryName.AutoSize = ((bool)(resources.GetObject("countryName.AutoSize")));
			this.countryName.Cursor = ((System.Windows.Forms.Cursor)(resources.GetObject("countryName.Cursor")));
			this.countryName.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("countryName.Dock")));
			this.countryName.Enabled = ((bool)(resources.GetObject("countryName.Enabled")));
			this.countryName.Font = ((System.Drawing.Font)(resources.GetObject("countryName.Font")));
			this.countryName.Image = ((System.Drawing.Image)(resources.GetObject("countryName.Image")));
			this.countryName.ImageAlign = ((System.Drawing.ContentAlignment)(resources.GetObject("countryName.ImageAlign")));
			this.countryName.ImageIndex = ((int)(resources.GetObject("countryName.ImageIndex")));
			this.countryName.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("countryName.ImeMode")));
			this.countryName.Location = ((System.Drawing.Point)(resources.GetObject("countryName.Location")));
			this.countryName.Name = "countryName";
			this.countryName.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("countryName.RightToLeft")));
			this.countryName.Size = ((System.Drawing.Size)(resources.GetObject("countryName.Size")));
			this.countryName.TabIndex = ((int)(resources.GetObject("countryName.TabIndex")));
			this.countryName.Text = resources.GetString("countryName.Text");
			this.countryName.TextAlign = ((System.Drawing.ContentAlignment)(resources.GetObject("countryName.TextAlign")));
			this.countryName.Visible = ((bool)(resources.GetObject("countryName.Visible")));
			// 
			// timeLabel
			// 
			this.timeLabel.AccessibleDescription = ((string)(resources.GetObject("timeLabel.AccessibleDescription")));
			this.timeLabel.AccessibleName = ((string)(resources.GetObject("timeLabel.AccessibleName")));
			this.timeLabel.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("timeLabel.Anchor")));
			this.timeLabel.AutoSize = ((bool)(resources.GetObject("timeLabel.AutoSize")));
			this.timeLabel.Cursor = ((System.Windows.Forms.Cursor)(resources.GetObject("timeLabel.Cursor")));
			this.timeLabel.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("timeLabel.Dock")));
			this.timeLabel.Enabled = ((bool)(resources.GetObject("timeLabel.Enabled")));
			this.timeLabel.Font = ((System.Drawing.Font)(resources.GetObject("timeLabel.Font")));
			this.timeLabel.Image = ((System.Drawing.Image)(resources.GetObject("timeLabel.Image")));
			this.timeLabel.ImageAlign = ((System.Drawing.ContentAlignment)(resources.GetObject("timeLabel.ImageAlign")));
			this.timeLabel.ImageIndex = ((int)(resources.GetObject("timeLabel.ImageIndex")));
			this.timeLabel.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("timeLabel.ImeMode")));
			this.timeLabel.Location = ((System.Drawing.Point)(resources.GetObject("timeLabel.Location")));
			this.timeLabel.Name = "timeLabel";
			this.timeLabel.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("timeLabel.RightToLeft")));
			this.timeLabel.Size = ((System.Drawing.Size)(resources.GetObject("timeLabel.Size")));
			this.timeLabel.TabIndex = ((int)(resources.GetObject("timeLabel.TabIndex")));
			this.timeLabel.Text = resources.GetString("timeLabel.Text");
			this.timeLabel.TextAlign = ((System.Drawing.ContentAlignment)(resources.GetObject("timeLabel.TextAlign")));
			this.timeLabel.Visible = ((bool)(resources.GetObject("timeLabel.Visible")));
			// 
			// flagImage
			// 
			this.flagImage.AccessibleDescription = ((string)(resources.GetObject("flagImage.AccessibleDescription")));
			this.flagImage.AccessibleName = ((string)(resources.GetObject("flagImage.AccessibleName")));
			this.flagImage.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("flagImage.Anchor")));
			this.flagImage.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("flagImage.BackgroundImage")));
			this.flagImage.Cursor = ((System.Windows.Forms.Cursor)(resources.GetObject("flagImage.Cursor")));
			this.flagImage.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("flagImage.Dock")));
			this.flagImage.Enabled = ((bool)(resources.GetObject("flagImage.Enabled")));
			this.flagImage.Font = ((System.Drawing.Font)(resources.GetObject("flagImage.Font")));
			this.flagImage.Image = ((System.Drawing.Bitmap)(resources.GetObject("flagImage.Image")));
			this.flagImage.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("flagImage.ImeMode")));
			this.flagImage.Location = ((System.Drawing.Point)(resources.GetObject("flagImage.Location")));
			this.flagImage.Name = "flagImage";
			this.flagImage.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("flagImage.RightToLeft")));
			this.flagImage.Size = ((System.Drawing.Size)(resources.GetObject("flagImage.Size")));
			this.flagImage.SizeMode = ((System.Windows.Forms.PictureBoxSizeMode)(resources.GetObject("flagImage.SizeMode")));
			this.flagImage.TabIndex = ((int)(resources.GetObject("flagImage.TabIndex")));
			this.flagImage.TabStop = false;
			this.flagImage.Text = resources.GetString("flagImage.Text");
			this.flagImage.Visible = ((bool)(resources.GetObject("flagImage.Visible")));
			// 
			// numberLabel
			// 
			this.numberLabel.AccessibleDescription = ((string)(resources.GetObject("numberLabel.AccessibleDescription")));
			this.numberLabel.AccessibleName = ((string)(resources.GetObject("numberLabel.AccessibleName")));
			this.numberLabel.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("numberLabel.Anchor")));
			this.numberLabel.AutoSize = ((bool)(resources.GetObject("numberLabel.AutoSize")));
			this.numberLabel.Cursor = ((System.Windows.Forms.Cursor)(resources.GetObject("numberLabel.Cursor")));
			this.numberLabel.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("numberLabel.Dock")));
			this.numberLabel.Enabled = ((bool)(resources.GetObject("numberLabel.Enabled")));
			this.numberLabel.Font = ((System.Drawing.Font)(resources.GetObject("numberLabel.Font")));
			this.numberLabel.Image = ((System.Drawing.Image)(resources.GetObject("numberLabel.Image")));
			this.numberLabel.ImageAlign = ((System.Drawing.ContentAlignment)(resources.GetObject("numberLabel.ImageAlign")));
			this.numberLabel.ImageIndex = ((int)(resources.GetObject("numberLabel.ImageIndex")));
			this.numberLabel.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("numberLabel.ImeMode")));
			this.numberLabel.Location = ((System.Drawing.Point)(resources.GetObject("numberLabel.Location")));
			this.numberLabel.Name = "numberLabel";
			this.numberLabel.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("numberLabel.RightToLeft")));
			this.numberLabel.Size = ((System.Drawing.Size)(resources.GetObject("numberLabel.Size")));
			this.numberLabel.TabIndex = ((int)(resources.GetObject("numberLabel.TabIndex")));
			this.numberLabel.Text = resources.GetString("numberLabel.Text");
			this.numberLabel.TextAlign = ((System.Drawing.ContentAlignment)(resources.GetObject("numberLabel.TextAlign")));
			this.numberLabel.Visible = ((bool)(resources.GetObject("numberLabel.Visible")));
			// 
			// usersTextBox
			// 
			this.usersTextBox.AccessibleDescription = ((string)(resources.GetObject("usersTextBox.AccessibleDescription")));
			this.usersTextBox.AccessibleName = ((string)(resources.GetObject("usersTextBox.AccessibleName")));
			this.usersTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("usersTextBox.Anchor")));
			this.usersTextBox.AutoSize = ((bool)(resources.GetObject("usersTextBox.AutoSize")));
			this.usersTextBox.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("usersTextBox.BackgroundImage")));
			this.usersTextBox.Cursor = ((System.Windows.Forms.Cursor)(resources.GetObject("usersTextBox.Cursor")));
			this.usersTextBox.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("usersTextBox.Dock")));
			this.usersTextBox.Enabled = ((bool)(resources.GetObject("usersTextBox.Enabled")));
			this.usersTextBox.Font = ((System.Drawing.Font)(resources.GetObject("usersTextBox.Font")));
			this.usersTextBox.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("usersTextBox.ImeMode")));
			this.usersTextBox.Location = ((System.Drawing.Point)(resources.GetObject("usersTextBox.Location")));
			this.usersTextBox.MaxLength = ((int)(resources.GetObject("usersTextBox.MaxLength")));
			this.usersTextBox.Multiline = ((bool)(resources.GetObject("usersTextBox.Multiline")));
			this.usersTextBox.Name = "usersTextBox";
			this.usersTextBox.PasswordChar = ((char)(resources.GetObject("usersTextBox.PasswordChar")));
			this.usersTextBox.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("usersTextBox.RightToLeft")));
			this.usersTextBox.ScrollBars = ((System.Windows.Forms.ScrollBars)(resources.GetObject("usersTextBox.ScrollBars")));
			this.usersTextBox.Size = ((System.Drawing.Size)(resources.GetObject("usersTextBox.Size")));
			this.usersTextBox.TabIndex = ((int)(resources.GetObject("usersTextBox.TabIndex")));
			this.usersTextBox.Text = resources.GetString("usersTextBox.Text");
			this.usersTextBox.TextAlign = ((System.Windows.Forms.HorizontalAlignment)(resources.GetObject("usersTextBox.TextAlign")));
			this.usersTextBox.Visible = ((bool)(resources.GetObject("usersTextBox.Visible")));
			this.usersTextBox.WordWrap = ((bool)(resources.GetObject("usersTextBox.WordWrap")));
			// 
			// reginoInfoLabel
			// 
			this.reginoInfoLabel.AccessibleDescription = ((string)(resources.GetObject("reginoInfoLabel.AccessibleDescription")));
			this.reginoInfoLabel.AccessibleName = ((string)(resources.GetObject("reginoInfoLabel.AccessibleName")));
			this.reginoInfoLabel.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("reginoInfoLabel.Anchor")));
			this.reginoInfoLabel.AutoSize = ((bool)(resources.GetObject("reginoInfoLabel.AutoSize")));
			this.reginoInfoLabel.BackColor = System.Drawing.SystemColors.Info;
			this.reginoInfoLabel.Cursor = ((System.Windows.Forms.Cursor)(resources.GetObject("reginoInfoLabel.Cursor")));
			this.reginoInfoLabel.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("reginoInfoLabel.Dock")));
			this.reginoInfoLabel.Enabled = ((bool)(resources.GetObject("reginoInfoLabel.Enabled")));
			this.reginoInfoLabel.Font = ((System.Drawing.Font)(resources.GetObject("reginoInfoLabel.Font")));
			this.reginoInfoLabel.Image = ((System.Drawing.Image)(resources.GetObject("reginoInfoLabel.Image")));
			this.reginoInfoLabel.ImageAlign = ((System.Drawing.ContentAlignment)(resources.GetObject("reginoInfoLabel.ImageAlign")));
			this.reginoInfoLabel.ImageIndex = ((int)(resources.GetObject("reginoInfoLabel.ImageIndex")));
			this.reginoInfoLabel.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("reginoInfoLabel.ImeMode")));
			this.reginoInfoLabel.Location = ((System.Drawing.Point)(resources.GetObject("reginoInfoLabel.Location")));
			this.reginoInfoLabel.Name = "reginoInfoLabel";
			this.reginoInfoLabel.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("reginoInfoLabel.RightToLeft")));
			this.reginoInfoLabel.Size = ((System.Drawing.Size)(resources.GetObject("reginoInfoLabel.Size")));
			this.reginoInfoLabel.TabIndex = ((int)(resources.GetObject("reginoInfoLabel.TabIndex")));
			this.reginoInfoLabel.Text = resources.GetString("reginoInfoLabel.Text");
			this.reginoInfoLabel.TextAlign = ((System.Drawing.ContentAlignment)(resources.GetObject("reginoInfoLabel.TextAlign")));
			this.reginoInfoLabel.Visible = ((bool)(resources.GetObject("reginoInfoLabel.Visible")));
			// 
			// calendar
			// 
			this.calendar.AccessibleDescription = ((string)(resources.GetObject("calendar.AccessibleDescription")));
			this.calendar.AccessibleName = ((string)(resources.GetObject("calendar.AccessibleName")));
			this.calendar.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("calendar.Anchor")));
			this.calendar.AutoSize = ((bool)(resources.GetObject("calendar.AutoSize")));
			this.calendar.Cursor = ((System.Windows.Forms.Cursor)(resources.GetObject("calendar.Cursor")));
			this.calendar.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("calendar.Dock")));
			this.calendar.Enabled = ((bool)(resources.GetObject("calendar.Enabled")));
			this.calendar.Font = ((System.Drawing.Font)(resources.GetObject("calendar.Font")));
			this.calendar.Image = ((System.Drawing.Image)(resources.GetObject("calendar.Image")));
			this.calendar.ImageAlign = ((System.Drawing.ContentAlignment)(resources.GetObject("calendar.ImageAlign")));
			this.calendar.ImageIndex = ((int)(resources.GetObject("calendar.ImageIndex")));
			this.calendar.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("calendar.ImeMode")));
			this.calendar.Location = ((System.Drawing.Point)(resources.GetObject("calendar.Location")));
			this.calendar.Name = "calendar";
			this.calendar.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("calendar.RightToLeft")));
			this.calendar.Size = ((System.Drawing.Size)(resources.GetObject("calendar.Size")));
			this.calendar.TabIndex = ((int)(resources.GetObject("calendar.TabIndex")));
			this.calendar.Text = resources.GetString("calendar.Text");
			this.calendar.TextAlign = ((System.Drawing.ContentAlignment)(resources.GetObject("calendar.TextAlign")));
			this.calendar.Visible = ((bool)(resources.GetObject("calendar.Visible")));
			// 
			// currencyLabel
			// 
			this.currencyLabel.AccessibleDescription = ((string)(resources.GetObject("currencyLabel.AccessibleDescription")));
			this.currencyLabel.AccessibleName = ((string)(resources.GetObject("currencyLabel.AccessibleName")));
			this.currencyLabel.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("currencyLabel.Anchor")));
			this.currencyLabel.AutoSize = ((bool)(resources.GetObject("currencyLabel.AutoSize")));
			this.currencyLabel.Cursor = ((System.Windows.Forms.Cursor)(resources.GetObject("currencyLabel.Cursor")));
			this.currencyLabel.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("currencyLabel.Dock")));
			this.currencyLabel.Enabled = ((bool)(resources.GetObject("currencyLabel.Enabled")));
			this.currencyLabel.Font = ((System.Drawing.Font)(resources.GetObject("currencyLabel.Font")));
			this.currencyLabel.Image = ((System.Drawing.Image)(resources.GetObject("currencyLabel.Image")));
			this.currencyLabel.ImageAlign = ((System.Drawing.ContentAlignment)(resources.GetObject("currencyLabel.ImageAlign")));
			this.currencyLabel.ImageIndex = ((int)(resources.GetObject("currencyLabel.ImageIndex")));
			this.currencyLabel.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("currencyLabel.ImeMode")));
			this.currencyLabel.Location = ((System.Drawing.Point)(resources.GetObject("currencyLabel.Location")));
			this.currencyLabel.Name = "currencyLabel";
			this.currencyLabel.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("currencyLabel.RightToLeft")));
			this.currencyLabel.Size = ((System.Drawing.Size)(resources.GetObject("currencyLabel.Size")));
			this.currencyLabel.TabIndex = ((int)(resources.GetObject("currencyLabel.TabIndex")));
			this.currencyLabel.Text = resources.GetString("currencyLabel.Text");
			this.currencyLabel.TextAlign = ((System.Drawing.ContentAlignment)(resources.GetObject("currencyLabel.TextAlign")));
			this.currencyLabel.Visible = ((bool)(resources.GetObject("currencyLabel.Visible")));
			// 
			// translatedText
			// 
			this.translatedText.AccessibleDescription = ((string)(resources.GetObject("translatedText.AccessibleDescription")));
			this.translatedText.AccessibleName = ((string)(resources.GetObject("translatedText.AccessibleName")));
			this.translatedText.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("translatedText.Anchor")));
			this.translatedText.AutoSize = ((bool)(resources.GetObject("translatedText.AutoSize")));
			this.translatedText.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("translatedText.BackgroundImage")));
			this.translatedText.Cursor = ((System.Windows.Forms.Cursor)(resources.GetObject("translatedText.Cursor")));
			this.translatedText.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("translatedText.Dock")));
			this.translatedText.Enabled = ((bool)(resources.GetObject("translatedText.Enabled")));
			this.translatedText.Font = ((System.Drawing.Font)(resources.GetObject("translatedText.Font")));
			this.translatedText.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("translatedText.ImeMode")));
			this.translatedText.Location = ((System.Drawing.Point)(resources.GetObject("translatedText.Location")));
			this.translatedText.MaxLength = ((int)(resources.GetObject("translatedText.MaxLength")));
			this.translatedText.Multiline = ((bool)(resources.GetObject("translatedText.Multiline")));
			this.translatedText.Name = "translatedText";
			this.translatedText.PasswordChar = ((char)(resources.GetObject("translatedText.PasswordChar")));
			this.translatedText.ReadOnly = true;
			this.translatedText.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("translatedText.RightToLeft")));
			this.translatedText.ScrollBars = ((System.Windows.Forms.ScrollBars)(resources.GetObject("translatedText.ScrollBars")));
			this.translatedText.Size = ((System.Drawing.Size)(resources.GetObject("translatedText.Size")));
			this.translatedText.TabIndex = ((int)(resources.GetObject("translatedText.TabIndex")));
			this.translatedText.Text = resources.GetString("translatedText.Text");
			this.translatedText.TextAlign = ((System.Windows.Forms.HorizontalAlignment)(resources.GetObject("translatedText.TextAlign")));
			this.translatedText.Visible = ((bool)(resources.GetObject("translatedText.Visible")));
			this.translatedText.WordWrap = ((bool)(resources.GetObject("translatedText.WordWrap")));
			// 
			// date
			// 
			this.date.AccessibleDescription = ((string)(resources.GetObject("date.AccessibleDescription")));
			this.date.AccessibleName = ((string)(resources.GetObject("date.AccessibleName")));
			this.date.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("date.Anchor")));
			this.date.AutoSize = ((bool)(resources.GetObject("date.AutoSize")));
			this.date.Cursor = ((System.Windows.Forms.Cursor)(resources.GetObject("date.Cursor")));
			this.date.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("date.Dock")));
			this.date.Enabled = ((bool)(resources.GetObject("date.Enabled")));
			this.date.Font = ((System.Drawing.Font)(resources.GetObject("date.Font")));
			this.date.Image = ((System.Drawing.Image)(resources.GetObject("date.Image")));
			this.date.ImageAlign = ((System.Drawing.ContentAlignment)(resources.GetObject("date.ImageAlign")));
			this.date.ImageIndex = ((int)(resources.GetObject("date.ImageIndex")));
			this.date.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("date.ImeMode")));
			this.date.Location = ((System.Drawing.Point)(resources.GetObject("date.Location")));
			this.date.Name = "date";
			this.date.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("date.RightToLeft")));
			this.date.Size = ((System.Drawing.Size)(resources.GetObject("date.Size")));
			this.date.TabIndex = ((int)(resources.GetObject("date.TabIndex")));
			this.date.Text = resources.GetString("date.Text");
			this.date.TextAlign = ((System.Drawing.ContentAlignment)(resources.GetObject("date.TextAlign")));
			this.date.Visible = ((bool)(resources.GetObject("date.Visible")));
			// 
			// metric
			// 
			this.metric.AccessibleDescription = ((string)(resources.GetObject("metric.AccessibleDescription")));
			this.metric.AccessibleName = ((string)(resources.GetObject("metric.AccessibleName")));
			this.metric.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("metric.Anchor")));
			this.metric.AutoSize = ((bool)(resources.GetObject("metric.AutoSize")));
			this.metric.Cursor = ((System.Windows.Forms.Cursor)(resources.GetObject("metric.Cursor")));
			this.metric.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("metric.Dock")));
			this.metric.Enabled = ((bool)(resources.GetObject("metric.Enabled")));
			this.metric.Font = ((System.Drawing.Font)(resources.GetObject("metric.Font")));
			this.metric.Image = ((System.Drawing.Image)(resources.GetObject("metric.Image")));
			this.metric.ImageAlign = ((System.Drawing.ContentAlignment)(resources.GetObject("metric.ImageAlign")));
			this.metric.ImageIndex = ((int)(resources.GetObject("metric.ImageIndex")));
			this.metric.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("metric.ImeMode")));
			this.metric.Location = ((System.Drawing.Point)(resources.GetObject("metric.Location")));
			this.metric.Name = "metric";
			this.metric.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("metric.RightToLeft")));
			this.metric.Size = ((System.Drawing.Size)(resources.GetObject("metric.Size")));
			this.metric.TabIndex = ((int)(resources.GetObject("metric.TabIndex")));
			this.metric.Text = resources.GetString("metric.Text");
			this.metric.TextAlign = ((System.Drawing.ContentAlignment)(resources.GetObject("metric.TextAlign")));
			this.metric.Visible = ((bool)(resources.GetObject("metric.Visible")));
			// 
			// time
			// 
			this.time.AccessibleDescription = ((string)(resources.GetObject("time.AccessibleDescription")));
			this.time.AccessibleName = ((string)(resources.GetObject("time.AccessibleName")));
			this.time.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("time.Anchor")));
			this.time.AutoSize = ((bool)(resources.GetObject("time.AutoSize")));
			this.time.Cursor = ((System.Windows.Forms.Cursor)(resources.GetObject("time.Cursor")));
			this.time.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("time.Dock")));
			this.time.Enabled = ((bool)(resources.GetObject("time.Enabled")));
			this.time.Font = ((System.Drawing.Font)(resources.GetObject("time.Font")));
			this.time.Image = ((System.Drawing.Image)(resources.GetObject("time.Image")));
			this.time.ImageAlign = ((System.Drawing.ContentAlignment)(resources.GetObject("time.ImageAlign")));
			this.time.ImageIndex = ((int)(resources.GetObject("time.ImageIndex")));
			this.time.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("time.ImeMode")));
			this.time.Location = ((System.Drawing.Point)(resources.GetObject("time.Location")));
			this.time.Name = "time";
			this.time.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("time.RightToLeft")));
			this.time.Size = ((System.Drawing.Size)(resources.GetObject("time.Size")));
			this.time.TabIndex = ((int)(resources.GetObject("time.TabIndex")));
			this.time.Text = resources.GetString("time.Text");
			this.time.TextAlign = ((System.Drawing.ContentAlignment)(resources.GetObject("time.TextAlign")));
			this.time.Visible = ((bool)(resources.GetObject("time.Visible")));
			// 
			// metricLabel
			// 
			this.metricLabel.AccessibleDescription = ((string)(resources.GetObject("metricLabel.AccessibleDescription")));
			this.metricLabel.AccessibleName = ((string)(resources.GetObject("metricLabel.AccessibleName")));
			this.metricLabel.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("metricLabel.Anchor")));
			this.metricLabel.AutoSize = ((bool)(resources.GetObject("metricLabel.AutoSize")));
			this.metricLabel.Cursor = ((System.Windows.Forms.Cursor)(resources.GetObject("metricLabel.Cursor")));
			this.metricLabel.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("metricLabel.Dock")));
			this.metricLabel.Enabled = ((bool)(resources.GetObject("metricLabel.Enabled")));
			this.metricLabel.Font = ((System.Drawing.Font)(resources.GetObject("metricLabel.Font")));
			this.metricLabel.Image = ((System.Drawing.Image)(resources.GetObject("metricLabel.Image")));
			this.metricLabel.ImageAlign = ((System.Drawing.ContentAlignment)(resources.GetObject("metricLabel.ImageAlign")));
			this.metricLabel.ImageIndex = ((int)(resources.GetObject("metricLabel.ImageIndex")));
			this.metricLabel.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("metricLabel.ImeMode")));
			this.metricLabel.Location = ((System.Drawing.Point)(resources.GetObject("metricLabel.Location")));
			this.metricLabel.Name = "metricLabel";
			this.metricLabel.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("metricLabel.RightToLeft")));
			this.metricLabel.Size = ((System.Drawing.Size)(resources.GetObject("metricLabel.Size")));
			this.metricLabel.TabIndex = ((int)(resources.GetObject("metricLabel.TabIndex")));
			this.metricLabel.Text = resources.GetString("metricLabel.Text");
			this.metricLabel.TextAlign = ((System.Drawing.ContentAlignment)(resources.GetObject("metricLabel.TextAlign")));
			this.metricLabel.Visible = ((bool)(resources.GetObject("metricLabel.Visible")));
			// 
			// currencyNumber
			// 
			this.currencyNumber.AccessibleDescription = ((string)(resources.GetObject("currencyNumber.AccessibleDescription")));
			this.currencyNumber.AccessibleName = ((string)(resources.GetObject("currencyNumber.AccessibleName")));
			this.currencyNumber.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("currencyNumber.Anchor")));
			this.currencyNumber.AutoSize = ((bool)(resources.GetObject("currencyNumber.AutoSize")));
			this.currencyNumber.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("currencyNumber.BackgroundImage")));
			this.currencyNumber.Cursor = ((System.Windows.Forms.Cursor)(resources.GetObject("currencyNumber.Cursor")));
			this.currencyNumber.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("currencyNumber.Dock")));
			this.currencyNumber.Enabled = ((bool)(resources.GetObject("currencyNumber.Enabled")));
			this.currencyNumber.Font = ((System.Drawing.Font)(resources.GetObject("currencyNumber.Font")));
			this.currencyNumber.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("currencyNumber.ImeMode")));
			this.currencyNumber.Location = ((System.Drawing.Point)(resources.GetObject("currencyNumber.Location")));
			this.currencyNumber.MaxLength = ((int)(resources.GetObject("currencyNumber.MaxLength")));
			this.currencyNumber.Multiline = ((bool)(resources.GetObject("currencyNumber.Multiline")));
			this.currencyNumber.Name = "currencyNumber";
			this.currencyNumber.PasswordChar = ((char)(resources.GetObject("currencyNumber.PasswordChar")));
			this.currencyNumber.ReadOnly = true;
			this.currencyNumber.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("currencyNumber.RightToLeft")));
			this.currencyNumber.ScrollBars = ((System.Windows.Forms.ScrollBars)(resources.GetObject("currencyNumber.ScrollBars")));
			this.currencyNumber.Size = ((System.Drawing.Size)(resources.GetObject("currencyNumber.Size")));
			this.currencyNumber.TabIndex = ((int)(resources.GetObject("currencyNumber.TabIndex")));
			this.currencyNumber.Text = resources.GetString("currencyNumber.Text");
			this.currencyNumber.TextAlign = ((System.Windows.Forms.HorizontalAlignment)(resources.GetObject("currencyNumber.TextAlign")));
			this.currencyNumber.Visible = ((bool)(resources.GetObject("currencyNumber.Visible")));
			this.currencyNumber.WordWrap = ((bool)(resources.GetObject("currencyNumber.WordWrap")));
			// 
			// languageSelection
			// 
			this.languageSelection.AccessibleDescription = ((string)(resources.GetObject("languageSelection.AccessibleDescription")));
			this.languageSelection.AccessibleName = ((string)(resources.GetObject("languageSelection.AccessibleName")));
			this.languageSelection.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("languageSelection.Anchor")));
			this.languageSelection.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("languageSelection.BackgroundImage")));
			this.languageSelection.Cursor = ((System.Windows.Forms.Cursor)(resources.GetObject("languageSelection.Cursor")));
			this.languageSelection.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("languageSelection.Dock")));
			this.languageSelection.DropDownWidth = 200;
			this.languageSelection.Enabled = ((bool)(resources.GetObject("languageSelection.Enabled")));
			this.languageSelection.Font = ((System.Drawing.Font)(resources.GetObject("languageSelection.Font")));
			this.languageSelection.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("languageSelection.ImeMode")));
			this.languageSelection.IntegralHeight = ((bool)(resources.GetObject("languageSelection.IntegralHeight")));
			this.languageSelection.ItemHeight = ((int)(resources.GetObject("languageSelection.ItemHeight")));
			this.languageSelection.Location = ((System.Drawing.Point)(resources.GetObject("languageSelection.Location")));
			this.languageSelection.MaxDropDownItems = ((int)(resources.GetObject("languageSelection.MaxDropDownItems")));
			this.languageSelection.MaxLength = ((int)(resources.GetObject("languageSelection.MaxLength")));
			this.languageSelection.Name = "languageSelection";
			this.languageSelection.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("languageSelection.RightToLeft")));
			this.languageSelection.Size = ((System.Drawing.Size)(resources.GetObject("languageSelection.Size")));
			this.languageSelection.TabIndex = ((int)(resources.GetObject("languageSelection.TabIndex")));
			this.languageSelection.Text = resources.GetString("languageSelection.Text");
			this.languageSelection.Visible = ((bool)(resources.GetObject("languageSelection.Visible")));
			this.languageSelection.SelectionChangeCommitted += new System.EventHandler(this.OnSelectionChangeCommited);
			// 
			// localeID
			// 
			this.localeID.AccessibleDescription = ((string)(resources.GetObject("localeID.AccessibleDescription")));
			this.localeID.AccessibleName = ((string)(resources.GetObject("localeID.AccessibleName")));
			this.localeID.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("localeID.Anchor")));
			this.localeID.AutoSize = ((bool)(resources.GetObject("localeID.AutoSize")));
			this.localeID.Cursor = ((System.Windows.Forms.Cursor)(resources.GetObject("localeID.Cursor")));
			this.localeID.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("localeID.Dock")));
			this.localeID.Enabled = ((bool)(resources.GetObject("localeID.Enabled")));
			this.localeID.Font = ((System.Drawing.Font)(resources.GetObject("localeID.Font")));
			this.localeID.Image = ((System.Drawing.Image)(resources.GetObject("localeID.Image")));
			this.localeID.ImageAlign = ((System.Drawing.ContentAlignment)(resources.GetObject("localeID.ImageAlign")));
			this.localeID.ImageIndex = ((int)(resources.GetObject("localeID.ImageIndex")));
			this.localeID.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("localeID.ImeMode")));
			this.localeID.Location = ((System.Drawing.Point)(resources.GetObject("localeID.Location")));
			this.localeID.Name = "localeID";
			this.localeID.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("localeID.RightToLeft")));
			this.localeID.Size = ((System.Drawing.Size)(resources.GetObject("localeID.Size")));
			this.localeID.TabIndex = ((int)(resources.GetObject("localeID.TabIndex")));
			this.localeID.Text = resources.GetString("localeID.Text");
			this.localeID.TextAlign = ((System.Drawing.ContentAlignment)(resources.GetObject("localeID.TextAlign")));
			this.localeID.Visible = ((bool)(resources.GetObject("localeID.Visible")));
			// 
			// exit
			// 
			this.exit.AccessibleDescription = ((string)(resources.GetObject("exit.AccessibleDescription")));
			this.exit.AccessibleName = ((string)(resources.GetObject("exit.AccessibleName")));
			this.exit.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("exit.Anchor")));
			this.exit.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("exit.BackgroundImage")));
			this.exit.Cursor = ((System.Windows.Forms.Cursor)(resources.GetObject("exit.Cursor")));
			this.exit.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("exit.Dock")));
			this.exit.Enabled = ((bool)(resources.GetObject("exit.Enabled")));
			this.exit.FlatStyle = ((System.Windows.Forms.FlatStyle)(resources.GetObject("exit.FlatStyle")));
			this.exit.Font = ((System.Drawing.Font)(resources.GetObject("exit.Font")));
			this.exit.Image = ((System.Drawing.Image)(resources.GetObject("exit.Image")));
			this.exit.ImageAlign = ((System.Drawing.ContentAlignment)(resources.GetObject("exit.ImageAlign")));
			this.exit.ImageIndex = ((int)(resources.GetObject("exit.ImageIndex")));
			this.exit.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("exit.ImeMode")));
			this.exit.Location = ((System.Drawing.Point)(resources.GetObject("exit.Location")));
			this.exit.Name = "exit";
			this.exit.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("exit.RightToLeft")));
			this.exit.Size = ((System.Drawing.Size)(resources.GetObject("exit.Size")));
			this.exit.TabIndex = ((int)(resources.GetObject("exit.TabIndex")));
			this.exit.Text = resources.GetString("exit.Text");
			this.exit.TextAlign = ((System.Drawing.ContentAlignment)(resources.GetObject("exit.TextAlign")));
			this.exit.Visible = ((bool)(resources.GetObject("exit.Visible")));
			this.exit.Click += new System.EventHandler(this.OnExit);
			// 
			// floatNumber
			// 
			this.floatNumber.AccessibleDescription = ((string)(resources.GetObject("floatNumber.AccessibleDescription")));
			this.floatNumber.AccessibleName = ((string)(resources.GetObject("floatNumber.AccessibleName")));
			this.floatNumber.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("floatNumber.Anchor")));
			this.floatNumber.AutoSize = ((bool)(resources.GetObject("floatNumber.AutoSize")));
			this.floatNumber.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("floatNumber.BackgroundImage")));
			this.floatNumber.Cursor = ((System.Windows.Forms.Cursor)(resources.GetObject("floatNumber.Cursor")));
			this.floatNumber.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("floatNumber.Dock")));
			this.floatNumber.Enabled = ((bool)(resources.GetObject("floatNumber.Enabled")));
			this.floatNumber.Font = ((System.Drawing.Font)(resources.GetObject("floatNumber.Font")));
			this.floatNumber.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("floatNumber.ImeMode")));
			this.floatNumber.Location = ((System.Drawing.Point)(resources.GetObject("floatNumber.Location")));
			this.floatNumber.MaxLength = ((int)(resources.GetObject("floatNumber.MaxLength")));
			this.floatNumber.Multiline = ((bool)(resources.GetObject("floatNumber.Multiline")));
			this.floatNumber.Name = "floatNumber";
			this.floatNumber.PasswordChar = ((char)(resources.GetObject("floatNumber.PasswordChar")));
			this.floatNumber.ReadOnly = true;
			this.floatNumber.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("floatNumber.RightToLeft")));
			this.floatNumber.ScrollBars = ((System.Windows.Forms.ScrollBars)(resources.GetObject("floatNumber.ScrollBars")));
			this.floatNumber.Size = ((System.Drawing.Size)(resources.GetObject("floatNumber.Size")));
			this.floatNumber.TabIndex = ((int)(resources.GetObject("floatNumber.TabIndex")));
			this.floatNumber.Text = resources.GetString("floatNumber.Text");
			this.floatNumber.TextAlign = ((System.Windows.Forms.HorizontalAlignment)(resources.GetObject("floatNumber.TextAlign")));
			this.floatNumber.Visible = ((bool)(resources.GetObject("floatNumber.Visible")));
			this.floatNumber.WordWrap = ((bool)(resources.GetObject("floatNumber.WordWrap")));
			// 
			// dateLabel
			// 
			this.dateLabel.AccessibleDescription = ((string)(resources.GetObject("dateLabel.AccessibleDescription")));
			this.dateLabel.AccessibleName = ((string)(resources.GetObject("dateLabel.AccessibleName")));
			this.dateLabel.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("dateLabel.Anchor")));
			this.dateLabel.AutoSize = ((bool)(resources.GetObject("dateLabel.AutoSize")));
			this.dateLabel.Cursor = ((System.Windows.Forms.Cursor)(resources.GetObject("dateLabel.Cursor")));
			this.dateLabel.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("dateLabel.Dock")));
			this.dateLabel.Enabled = ((bool)(resources.GetObject("dateLabel.Enabled")));
			this.dateLabel.Font = ((System.Drawing.Font)(resources.GetObject("dateLabel.Font")));
			this.dateLabel.Image = ((System.Drawing.Image)(resources.GetObject("dateLabel.Image")));
			this.dateLabel.ImageAlign = ((System.Drawing.ContentAlignment)(resources.GetObject("dateLabel.ImageAlign")));
			this.dateLabel.ImageIndex = ((int)(resources.GetObject("dateLabel.ImageIndex")));
			this.dateLabel.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("dateLabel.ImeMode")));
			this.dateLabel.Location = ((System.Drawing.Point)(resources.GetObject("dateLabel.Location")));
			this.dateLabel.Name = "dateLabel";
			this.dateLabel.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("dateLabel.RightToLeft")));
			this.dateLabel.Size = ((System.Drawing.Size)(resources.GetObject("dateLabel.Size")));
			this.dateLabel.TabIndex = ((int)(resources.GetObject("dateLabel.TabIndex")));
			this.dateLabel.Text = resources.GetString("dateLabel.Text");
			this.dateLabel.TextAlign = ((System.Drawing.ContentAlignment)(resources.GetObject("dateLabel.TextAlign")));
			this.dateLabel.Visible = ((bool)(resources.GetObject("dateLabel.Visible")));
			// 
			// calendarLabel
			// 
			this.calendarLabel.AccessibleDescription = ((string)(resources.GetObject("calendarLabel.AccessibleDescription")));
			this.calendarLabel.AccessibleName = ((string)(resources.GetObject("calendarLabel.AccessibleName")));
			this.calendarLabel.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("calendarLabel.Anchor")));
			this.calendarLabel.AutoSize = ((bool)(resources.GetObject("calendarLabel.AutoSize")));
			this.calendarLabel.Cursor = ((System.Windows.Forms.Cursor)(resources.GetObject("calendarLabel.Cursor")));
			this.calendarLabel.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("calendarLabel.Dock")));
			this.calendarLabel.Enabled = ((bool)(resources.GetObject("calendarLabel.Enabled")));
			this.calendarLabel.Font = ((System.Drawing.Font)(resources.GetObject("calendarLabel.Font")));
			this.calendarLabel.Image = ((System.Drawing.Image)(resources.GetObject("calendarLabel.Image")));
			this.calendarLabel.ImageAlign = ((System.Drawing.ContentAlignment)(resources.GetObject("calendarLabel.ImageAlign")));
			this.calendarLabel.ImageIndex = ((int)(resources.GetObject("calendarLabel.ImageIndex")));
			this.calendarLabel.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("calendarLabel.ImeMode")));
			this.calendarLabel.Location = ((System.Drawing.Point)(resources.GetObject("calendarLabel.Location")));
			this.calendarLabel.Name = "calendarLabel";
			this.calendarLabel.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("calendarLabel.RightToLeft")));
			this.calendarLabel.Size = ((System.Drawing.Size)(resources.GetObject("calendarLabel.Size")));
			this.calendarLabel.TabIndex = ((int)(resources.GetObject("calendarLabel.TabIndex")));
			this.calendarLabel.Text = resources.GetString("calendarLabel.Text");
			this.calendarLabel.TextAlign = ((System.Drawing.ContentAlignment)(resources.GetObject("calendarLabel.TextAlign")));
			this.calendarLabel.Visible = ((bool)(resources.GetObject("calendarLabel.Visible")));
			// 
			// GlobalForm
			// 
			this.AccessibleDescription = ((string)(resources.GetObject("$this.AccessibleDescription")));
			this.AccessibleName = ((string)(resources.GetObject("$this.AccessibleName")));
			this.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("$this.Anchor")));
			this.AutoScaleBaseSize = ((System.Drawing.Size)(resources.GetObject("$this.AutoScaleBaseSize")));
			this.AutoScroll = ((bool)(resources.GetObject("$this.AutoScroll")));
			this.AutoScrollMargin = ((System.Drawing.Size)(resources.GetObject("$this.AutoScrollMargin")));
			this.AutoScrollMinSize = ((System.Drawing.Size)(resources.GetObject("$this.AutoScrollMinSize")));
			this.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("$this.BackgroundImage")));
			this.ClientSize = ((System.Drawing.Size)(resources.GetObject("$this.ClientSize")));
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.time,
																		  this.timeLabel,
																		  this.usersTextBox,
																		  this.reginoInfoLabel,
																		  this.countryName,
																		  this.metric,
																		  this.metricLabel,
																		  this.currencyLabel,
																		  this.numberLabel,
																		  this.dateLabel,
																		  this.calendarLabel,
																		  this.LCIDLabel,
																		  this.localeID,
																		  this.currencyNumber,
																		  this.floatNumber,
																		  this.calendar,
																		  this.date,
																		  this.exit,
																		  this.translatedText,
																		  this.flagImage,
																		  this.languageSelection});
			this.Cursor = ((System.Windows.Forms.Cursor)(resources.GetObject("$this.Cursor")));
			this.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("$this.Dock")));
			this.Enabled = ((bool)(resources.GetObject("$this.Enabled")));
			this.Font = ((System.Drawing.Font)(resources.GetObject("$this.Font")));
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("$this.ImeMode")));
			this.Location = ((System.Drawing.Point)(resources.GetObject("$this.Location")));
			this.MaximumSize = ((System.Drawing.Size)(resources.GetObject("$this.MaximumSize")));
			this.MinimumSize = ((System.Drawing.Size)(resources.GetObject("$this.MinimumSize")));
			this.Name = "GlobalForm";
			this.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("$this.RightToLeft")));
			this.StartPosition = ((System.Windows.Forms.FormStartPosition)(resources.GetObject("$this.StartPosition")));
			this.Text = resources.GetString("$this.Text");
			this.Visible = ((bool)(resources.GetObject("$this.Visible")));
			this.Load += new System.EventHandler(this.GlobalForm_Load);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// Gwny punkt wejcia dla aplikacji.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Thread.CurrentThread.CurrentCulture = new CultureInfo("en-US");
			Thread.CurrentThread.CurrentUICulture = Thread.CurrentThread.CurrentCulture;
			Application.Run(new GlobalForm());
		}

		private void OnExit(object sender, System.EventArgs e)
		{
			Application.Exit();
		}

		private void OnSound(object sender, System.EventArgs e)
		{

		}

		private void OnSelectionChangeCommited(object sender, System.EventArgs e)
		{
			try
			{
				LanguageIdentifier li = (LanguageIdentifier)languageSelection.SelectedItem;
				Text = "GlobalApp " + li.Message;
				Thread.CurrentThread.CurrentUICulture = new CultureInfo(li.CultureString);
				Thread.CurrentThread.CurrentCulture = Thread.CurrentThread.CurrentUICulture;
				ResourceManager rm = new ResourceManager("GlobalApp.GlobalForm", Assembly.GetExecutingAssembly());
				flagImage.Image = (System.Drawing.Image)rm.GetObject("flagImage.Image");
				translatedText.Text = (string)rm.GetObject("translatedText.Text");
//				string audio = (string)rm.GetObject("audio");
//				audio = audio.Trim();
//				if(audio.Length > 0)
//				{
//					Process.Start(li.CultureString + @"\" + audio);
//				}
				CultureInfo ci = Thread.CurrentThread.CurrentUICulture;

				// Informacje lokalne
				localeID.Text = Convert.ToString(ci.LCID);

				// Kalendarz
				if(ci.Calendar is GregorianCalendar)
				{
					calendar.Text = "Gregoriaski";
				}
				else if(ci.Calendar is HebrewCalendar)
				{
					calendar.Text = "ydowski";
				}
				else if(ci.Calendar is HijriCalendar)
				{
					calendar.Text = "Hijri";
				}
				else if(ci.Calendar is JapaneseCalendar)
				{
					calendar.Text = "Japoski";
				}
				else if(ci.Calendar is JulianCalendar)
				{
					calendar.Text = "Juliaski";
				}
				else if(ci.Calendar is KoreanCalendar)
				{
					calendar.Text = "Koreaski";
				}
				else if(ci.Calendar is TaiwanCalendar)
				{
					calendar.Text = "Tajwaski";
				}
				else if(ci.Calendar is ThaiBuddhistCalendar)
				{
					calendar.Text = "Tajski";
				}
				else
				{
					calendar.Text = "";

				}
				DateTime now = DateTime.Now;
				time.Text = now.ToLongTimeString();
				date.Text = now.ToLongDateString();
				double d = 1000000.0;
				floatNumber.Text = String.Format("{0:N}", d);
				currencyNumber.Text = String.Format("{0:C}", d);

				// Informacje o regionie
				RegionInfo ri = new RegionInfo(ci.LCID);
				metric.Text = Convert.ToString(ri.IsMetric);
				countryName.Text = ri.DisplayName;
			}
			catch(Exception exception)
			{
				Debug.WriteLine(exception);
			}
		}

		private void GlobalForm_Load(object sender, System.EventArgs e)
		{

		}
	}
}
